/*
------------------------------------------------------------------------
  Programme: ANAFACT.C

  Module   : Programme principal
			      Borland Turbo C++ version 1.00

  Auteur   : Jean Philippe BOCQUENET

  Date     : 16/IV/1995

  Objet    : Programme d'analyses factorielles

-----------------------------------------------------------------------
*/

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>

#define ESC           		0x011B
#define DEL 			0x0E08
#define TAB			0x0F09
#define ENTER         		0x1C0D
#define F1            		0x3B00
#define F2  	      		0x3c00
#define F3  	      		0x3d00
#define F4  	      		0x3e00
#define F5  	      		0x3f00
#define F6  	      		0x4000
#define F7  	      		0x4100
#define F8  	      		0x4200
#define F9  	      		0x4300
#define F10 	      		0x4400
#define FL_HAUT       		0x4800
#define FL_BAS        		0x5000
#define SHIFT_F10     		0x5d00

int a[50][50], ligne, colonne;

/* ------------------------------------------------------------------------ */
void fichier_cor(void)
{
 int i, j;

 clrscr();
 for (i=1;i<=ligne;i++)
 {
  for(j=1;j<=colonne;j++)
  {
   gotoxy(20,17); cprintf("Ligne   : %d",i);
   gotoxy(20,18); cprintf("Colonne : %d",j);
   gotoxy(20,20); cprintf("Valeur :");
   gotoxy(29,20); scanf("%d",&a[i][j]);
  }
 }
 for (i=1;i<=ligne;i++)
 {
  for(j=1;j<=colonne;j++)
  {
   a[j][i] = a[i][j];
  }
 }
}

/* ------------------------------------------------------------------------ */
void fichier_mat(void)
{
 int i, j;

 clrscr();
 for (i=1;i<=ligne;i++)
 {
  for(j=1;j<=colonne;j++)
  {
   gotoxy(20,17); cprintf("Ligne   : %d",i);
   gotoxy(20,18); cprintf("Colonne : %d",j);
   gotoxy(20,20); cprintf("Valeur :");
   gotoxy(29,20); scanf("%d",&a[i][j]);
  }
 }
}

/* ------------------------------------------------------------------------ */
void saisie(void)
{
  FILE *fic;
  char fichier[15];
  int ptr, i, j;

  clrscr();
  gotoxy(10,10); cprintf("Nom du fichier  ouvrir : ");
  gotoxy(10,12); cprintf("Avec l'extension *.COR pour un tableau de corrlations");
  gotoxy(10,13); cprintf("Avec l'extension *.MAT pour un tableau de contingence");
  gotoxy(36,10); scanf("%12s",fichier);
  gotoxy(20,17); cprintf("Nombre de lignes   :");
  gotoxy(20,18); cprintf("Nombre de colonnes :");
  gotoxy(41,17); scanf("%d",&ligne);
  gotoxy(41,18); scanf("%d",&colonne);

  strrev(fichier);
  ptr=strncmpi(fichier,"TAM.",4);
  if (ptr==0) { fichier_mat(); }
  ptr=strncmpi(fichier,"ROC.",4);
  if (ptr==0) { fichier_cor(); }
  strrev(fichier);

  fic = fopen(fichier,"a+t");

  fprintf(fic,"%d,%d\n",ligne,colonne);
  for (i=1;i<=ligne;i++)
  {
   for(j=1;j<=colonne;j++)
   {
    fprintf(fic,"%d,",a[i][j]);
   }
   fprintf(fic,"\n");
  }
  fclose(fic);
}

/* ------------------------------------------------------------------------ */
void ecran_pres_lecture(void)
{
  gotoxy(10,18); cprintf("Afficher le contenu du fichier  l'cran........[F1]");
  gotoxy(10,20); cprintf("Retour au menu principal.......................[ESC]");
}

/* ------------------------------------------------------------------------ */
void lecture(void)
{
  FILE *fic;
  char fichier[15];
  int ptr, i, j, fin, pause;
  unsigned int touche;

  clrscr();
  gotoxy(10,10); cprintf("Nom du fichier  ouvrir : ");
  gotoxy(36,10); scanf("%12s",fichier);

  fic = fopen(fichier,"a+t");
  fscanf(fic,"%d,%d\n",&ligne,&colonne);

  gotoxy(10,15); cprintf("Le fichier -%s- possde %d lignes et %d colonnes",\
	fichier,ligne,colonne);

 ecran_pres_lecture();

 for(;;)
 {
  touche = bioskey(0);
  switch(touche)
  {

   case F1:
	     clrscr();
	     pause=1;
	     for(i=1;i<=ligne;i++)
	     {
	      for(j=1;j<=colonne;j++)
	      {
	       fscanf(fic,"%d,",&a[i][j]);
	       gotoxy(j*5,pause);
	       cprintf("%d,",a[i][j]);
	       if(pause>=23)
		{
		 gotoxy(10,24); cprintf("Appuyez sur une touche pour continuer");
		 getch();
		 clrscr();
		 pause=1;
		}
	      }
	       fscanf(fic,"\n");
	       pause=pause+1;
	     }
	     getch();
	     clrscr();
	     ecran_pres_lecture();
	     break;
   case ESC:
	     return;
  }
 }
}






/* ------------------------------------------------------------------------ */
void ecran_menu(void)
{
  clrscr();
  gotoxy(20,2); cprintf("ANALYSE FACTORIELLE DES CORRESPONDANCES");
  gotoxy(35,5); cprintf("MENU");
  gotoxy(15,8); cprintf("Saisie d'un tableau........................[F1]");
  gotoxy(15,9); cprintf("Lecture d'un tableau *.MAT.................[F2]");
  gotoxy(15,10);cprintf("Calculer une analyse des correspondances...[F3]");
  gotoxy(15,11);cprintf("Corriger un tableau *.MAT..................[F4]");
  gotoxy(15,12);cprintf("Ajouter des lignes ou des colonnes.(*.MAT).[F5]");
  gotoxy(15,13);cprintf("Visualisation d'un graphique...............[F6]");
  gotoxy(15,15);cprintf("Sortie du programme................[SHIFT][F10]");
}

/* ------------------------------------------------------------------------ */
void menu(void)
{
unsigned int touch;

 for(;touch!=SHIFT_F10;)
 {
   if ((bioskey(1) == 0))
   {
     touch = bioskey(0);
     switch(touch)
    {
	      case F1:
		       saisie();
		       clrscr();
		       ecran_menu();
		       break;
	      case F2:
		       lecture();
		       clrscr();
		       ecran_menu();
		       break;
	      case F3:
		       /* corresp2(); */
		       ecran_menu();
		       break;
	      case F4:
		       /* correct1(); */
		       ecran_menu();
		       break;
	      case F5:
		       /* ajout2(); */
		       ecran_menu();
		       break;
	      case F6:
		       /* graph1(); */
		       ecran_menu();
		       break;
	      default:
		       break;
    }
   }
 }
 clrscr();
}

/* ------------------------------------------------------------------------ */
void main(void)
{
  ecran_menu();
  menu();
  exit(0);
}
